import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.sql.Date;
import java.util.GregorianCalendar;
import java.util.Vector;

import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;

public class GetAllParameters extends Applet {

	static final long serialVersionUID = 1;

	public static void main(String[] args) {

		try {
			GetAllParameters report = new GetAllParameters();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", report.doGetAllParameters(frame));
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public void init() {
		setLayout(new BorderLayout());
		add("Center", doGetAllParameters(this));
	}

	Component doGetAllParameters(Object parent) {

		// Do not use EspressManager
		QbReport.setEspressManagerUsed(false);

		// Object array for Query Parameters
		Vector vec = new Vector();
		vec.addElement("CA");
		vec.addElement("NY");

		GregorianCalendar beginDate = new GregorianCalendar(2001, 0, 4);
		GregorianCalendar endDate = new GregorianCalendar(2003, 1, 12);

		long beginLong = beginDate.getTimeInMillis();
		long endLong = endDate.getTimeInMillis();

		Date beginDateTime = new Date(beginLong);
		Date endDateTime = new Date(endLong);

		Object queryParams[] = new Object[3];
		queryParams[0] = vec;
		queryParams[1] = beginDateTime;
		queryParams[2] = endDateTime;

		// Object array for Formula Parameter
		Object formulaParams[] = new Object[1];
		formulaParams[0] = "Sarat";

		// Open the template with backup data
		QbReport report = new QbReport(parent, // container 
				"ObjectArray.rpt", // template
				false, false, false, true);

		// Pass in parameters using getAllParameters
		report.getAllParameters().get(0).setValues((Vector) queryParams[0]);
		report.getAllParameters().get(1).setValue(queryParams[1]);
		report.getAllParameters().get(2).setValue(queryParams[2]);
		report.getAllParameters().get(3).setValue(formulaParams[0]);

		try {
			// Get the data for the report
			report.refreshWithOriginalData();
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}

		// Show report in Viewer
		return (new Viewer().getComponent(report));
	}

}
